import { gszsTableData, jstjTableData, nfTableData, tkjsTableData } from "../../data/table/constructData";
import { keyValuePackage, onceYBarChartPackage, stringListPackage } from "../../dataPackage/inFrontOut";
import { getKeyValueOut, getOnceYBarChartOut, getStringOut } from "../../dataPackage/out";


/**年份 */
export function getYear(req, res) {
    let excelData = nfTableData();

    let ret:any = {};

    let nfPackageData = stringListPackage(excelData['下拉年份'].dataList);
    ret['nf'] = getStringOut('下拉年份', nfPackageData);
                  
    res.send(ret);
}


/**概算总数 */
export function getFinancialestimates(req, res) {
    let year = req.query.year || 2023; //年份
    let excelData = gszsTableData();

    let ret:any = {};

    let index = 1;
    for (let key in excelData) {
        if (key.search(year) > -1) { //匹配年份
            let gszsPackageData = keyValuePackage(excelData[key].dataList);
            ret["api" + index] = getKeyValueOut(key, gszsPackageData);
            index++;
        }
    }
                  
    res.send(ret);
}


/**投控建设 */
export function getInvestmentcontrol(req, res) {
    let year = req.query.year || 2023; //年份
    let excelData = tkjsTableData();

    let ret:any = {};
    
    let index = 1;
    for (let key in excelData) {
        if (key.search(year) > -1) { //匹配年份
            let tkjsPackageData = onceYBarChartPackage( excelData[key], '','');
            ret["api" + index] = getOnceYBarChartOut(key, tkjsPackageData);
            index ++;
        }
    }
                    
    res.send(ret);
}


/**决算统计 */
export function getFinalaccounts(req, res) {
    let year = req.query.year || 2023; //年份
    let line = req.query.line || "全部"; //线路
    let excelData = jstjTableData();

    let ret:any = {};
   
    let tkjsExcelData:any = {};
    let index = 1;
    for (let key in excelData) {
        if (key.search(year) > -1) { //匹配年份
            let lineData = excelData[key];
            lineData.forEach( info => {
                let {name, data} = info;
                if (name == line) { //判断线路
                    tkjsExcelData = info;
                }
            })
            
            ret["api" + index] = tkjsExcelData;
            
            if (index == 2) {
                let itemTotal = 0;
                tkjsExcelData.data.forEach(item => {
                    itemTotal += item.value || 0;
                });
                ret["api" + index].total = itemTotal;
            }
            
            index++;
        }
    }
                    
    res.send(ret);
}

